/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.82 Revision 1.143
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.82 2010/08/14 18:09:10 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.143 2013/03/02 21:44:33 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 3|4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 44[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21else 45[[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
22 MY_P=qt-x11-opensource-src-${MY_PV} 46
47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
23fi 50fi
24 51
25HOMEPAGE="http://qt.nokia.com/"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND="
32 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV}
51 !>x11-libs/qt-script-${PV}-r9999
52 !<x11-libs/qt-sql-${PV}
53 !>x11-libs/qt-sql-${PV}-r9999
54 !<x11-libs/qt-svg-${PV}
55 !>x11-libs/qt-svg-${PV}-r9999
56 !<x11-libs/qt-test-${PV}
57 !>x11-libs/qt-test-${PV}-r9999
58 !<x11-libs/qt-webkit-${PV}
59 !>x11-libs/qt-webkit-${PV}-r9999
60 !<x11-libs/qt-xmlpatterns-${PV}
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999
62"
63
64S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
65 53
66# @FUNCTION: qt4-build_pkg_setup 54# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 55# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 56# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71
72 # Protect users by not allowing downgrades between releases 58 # Protect users by not allowing downgrades between releases.
73 # Downgrading revisions within the same release should be allowed 59 # Downgrading revisions within the same release should be allowed.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 62 eerror " *** Sanity check to keep you from breaking your system ***"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 64 die "aborting to save your system"
79 else 65 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 67 fi
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([1-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 68 fi
96 69
97 PATH="${S}/bin${PATH:+:}${PATH}" 70 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 71 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 77 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 78 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 80 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 81 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
122 89
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
124# @DESCRIPTION: 92# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 93# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 94# code should be compiled. This is a space-separated list.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 95
133# @FUNCTION: qt4-build_src_unpack 96# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 97# @DESCRIPTION:
135# Unpacks the sources 98# Unpacks the sources.
136qt4-build_src_unpack() { 99qt4-build_src_unpack() {
137 setqtenv 100 setqtenv
138 local target targets= 101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 fi
105
106 if [[ ${PN} == qt-webkit ]]; then
107 eshopts_push -s extglob
108 if is-flagq '-g?(gdb)?([1-9])'; then
109 echo
110 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
111 ewarn "You may experience really long compilation times and/or increased memory usage."
112 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
113 ewarn "For more info check out https://bugs.gentoo.org/307861"
114 echo
115 fi
116 eshopts_pop
117 fi
118
119 case ${QT4_BUILD_TYPE} in
120 live)
121 git-2_src_unpack
122 ;;
123 release)
124 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 125 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 126 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 127 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
128 do
142 targets+=" ${MY_P}/${target}" 129 targets+="${MY_P}/${target} "
143 done 130 done
144 131
132 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 133 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 134 eend $? || die "failed to unpack"
135 ;;
136 esac
147} 137}
148 138
149# @ECLASS-VARIABLE: PATCHES 139# @ECLASS-VARIABLE: PATCHES
140# @DEFAULT_UNSET
150# @DESCRIPTION: 141# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 142# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 143# This variable is expected to be defined in global scope of ebuild.
153# example: 144# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 145# src_prepare() phase.
155# ${FILESDIR}"/mypatch2.patch"
156# 146#
147# @CODE
148# PATCHES=( "${FILESDIR}/mypatch.patch"
149# "${FILESDIR}/patches_folder/" )
150# @CODE
157 151
158# @FUNCTION: qt4-build_src_prepare 152# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 153# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 154# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 155# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
162qt4-build_src_prepare() { 156qt4-build_src_prepare() {
163 setqtenv 157 setqtenv
164 cd "${S}" 158
165 159 if [[ ${QT4_BUILD_TYPE} == live ]]; then
166 # fix qt 4.7 regression that skips -fvisibility=hidden 160 QTDIR="." ./bin/syncqt || die "syncqt failed"
167 if version_is_at_least "4.7.0_beta1"; then
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 161 fi
162
172 # fix libx11 dependency on non X packages 163 # avoid X11 dependency in non-gui packages
173 if version_is_at_least "4.7.0_beta2"; then
174 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 164 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
175 hasq ${PN} ${NOLIBX11PKG} && qt_nolibx11 165 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
176 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
177 fi
178 166
179 if use aqua; then 167 if use aqua; then
180 # provide a proper macx-g++-64 168 # provide a proper macx-g++-64
181 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 169 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
182 170
183 sed -e '/^CONFIG/s:app_bundle::' \ 171 sed -e '/^CONFIG/s:app_bundle::' \
184 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 172 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
185 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 173 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
186 fi 174 fi
187 175
188 if [[ ${PN} != qt-core ]]; then 176 if [[ ${PN} != qt-core ]]; then
189 skip_qmake_build_patch 177 skip_qmake_build
190 skip_project_generation_patch 178 skip_project_generation
191 symlink_binaries_to_buildtree 179 symlink_binaries_to_buildtree
192 fi 180 fi
193 181
194 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 182 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
195 # qmake bus errors with -O2 but -O3 works 183 # qmake bus errors with -O2 or -O3 but -O1 works
184 # Bug 373061
196 replace-flags -O2 -O3 185 replace-flags -O[23] -O1
197 fi
198
199 if [[ ${CHOST} == arm* ]] ; then
200 # Fails on arm with -Os, bug 331641
201 # This can be removed once qt-4.7 is stable or the bug on gcc is fixed
202 replace-flags -Os -O2
203 fi 186 fi
204 187
205 # Bug 178652 188 # Bug 178652
206 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 189 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
207 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 190 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
208 append-flags -fno-gcse 191 append-flags -fno-gcse
209 fi 192 fi
210 193
194 if use_if_iuse c++0x; then
195 append-cxxflags -std=c++0x
196 fi
197
211 # Unsupported old gcc versions - hardened needs this :( 198 # Unsupported old gcc versions - hardened needs this :(
212 if [[ $(gcc-major-version) -lt 4 ]] ; then 199 if [[ $(gcc-major-version) -lt 4 ]]; then
213 ewarn "Appending -fno-stack-protector to CXXFLAGS" 200 ewarn "Appending -fno-stack-protector to CXXFLAGS"
214 append-cxxflags -fno-stack-protector 201 append-cxxflags -fno-stack-protector
215 # Bug 253127 202 # Bug 253127
216 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 203 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
217 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 204 -i mkspecs/common/g++.conf || die
218 fi 205 fi
219 206
220 # Bug 261632 207 # Bug 261632
221 if use ppc64; then 208 if use ppc64; then
222 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 209 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
223 append-flags -mminimal-toc 210 append-flags -mminimal-toc
224 fi 211 fi
225 212
226 # Bug 282984 && Bug 295530 213 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
227 sed -e "s:\(^SYSTEM_VARIABLES\):CC="$(tc-getCC)"\nCXX="$(tc-getCXX)"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 214 sed -e "/^SYSTEM_VARIABLES=/i \
228 -i configure || die "sed qmake compilers failed" 215 CC='$(tc-getCC)'\n\
229 # bug 321335 216 CXX='$(tc-getCXX)'\n\
230 if version_is_at_least 4.6; then 217 CFLAGS='${CFLAGS}'\n\
231 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 218 CXXFLAGS='${CXXFLAGS}'\n\
232 xargs -0 \ 219 LDFLAGS='${LDFLAGS}'\n\
233 sed -e "s:\(\$MAKE\):\1 CC="$(tc-getCC)" CXX="$(tc-getCXX)" LD="$(tc-getCXX)" LINK="$(tc-getCXX)":g" \ 220 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
234 -i || die "sed test compilers failed" 221 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
235 fi 222 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
223 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
224 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
225 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
226 -i configure \
227 || die "sed SYSTEM_VARIABLES failed"
228
229 # Respect CC, CXX, LINK and *FLAGS in config.tests
230 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
231 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
232 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
233 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
234 || die "sed config.tests failed"
236 235
237 # Bug 172219 236 # Bug 172219
238 sed -e "s:X11R6/::" \ 237 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
239 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
240 238
241 if [[ ${CHOST} == *-darwin* ]]; then 239 if [[ ${CHOST} == *-darwin* ]]; then
242 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 240 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
243 # crippled (by design) :/ 241 # crippled (by design) :/
242 local mac_gpp_conf=
243 if [[ -f mkspecs/common/mac-g++.conf ]]; then
244 # qt < 4.8 has mac-g++.conf
245 mac_gpp_conf="mkspecs/common/mac-g++.conf"
246 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
247 # qt >= 4.8 has g++-macx.conf
248 mac_gpp_conf="mkspecs/common/g++-macx.conf"
249 else
250 die "no known conf file for mac found"
251 fi
252 sed \
244 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 253 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
245 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 254 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
246 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 255 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
247 -e "s:-arch\s\w*::g" \ 256 -e "s:-arch\s\w*::g" \
248 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 257 -i ${mac_gpp_conf} \
258 || die "sed ${mac_gpp_conf} failed"
249 259
250 # Fix configure's -arch settings that appear in qmake/Makefile and also 260 # Fix configure's -arch settings that appear in qmake/Makefile and also
251 # fix arch handling (automagically duplicates our -arch arg and breaks 261 # fix arch handling (automagically duplicates our -arch arg and breaks
252 # pch). Additionally disable Xarch support. 262 # pch). Additionally disable Xarch support.
263 local mac_gcc_confs="${mac_gpp_conf}"
264 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
265 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
266 fi
253 sed \ 267 sed \
254 -e "s:-arch i386::" \ 268 -e "s:-arch i386::" \
255 -e "s:-arch ppc::" \ 269 -e "s:-arch ppc::" \
256 -e "s:-arch x86_64::" \ 270 -e "s:-arch x86_64::" \
257 -e "s:-arch ppc64::" \ 271 -e "s:-arch ppc64::" \
258 -e "s:-arch \$i::" \ 272 -e "s:-arch \$i::" \
259 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 273 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
260 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 274 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
261 -e "s:-Xarch_x86_64::g" \ 275 -e "s:-Xarch_x86_64::g" \
262 -e "s:-Xarch_ppc64::g" \ 276 -e "s:-Xarch_ppc64::g" \
263 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 277 -i configure ${mac_gcc_confs} \
278 || die "sed -arch/-Xarch failed"
264 279
265 # On Snow Leopard don't fall back to 10.5 deployment target. 280 # On Snow Leopard don't fall back to 10.5 deployment target.
266 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 281 if [[ ${CHOST} == *-apple-darwin10 ]]; then
267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 282 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 283 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
269 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 284 -i configure ${mac_gpp_conf} \
285 || die "sed deployment target failed"
270 fi 286 fi
271 fi 287 fi
272 288
273 # this one is needed for all systems with a separate -liconv, apart from 289 # this one is needed for all systems with a separate -liconv, apart from
274 # Darwin, for which the sources already cater for -liconv 290 # Darwin, for which the sources already cater for -liconv
275 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 291 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
276 sed \ 292 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
277 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
278 -i config.tests/unix/iconv/iconv.pro \ 293 -i config.tests/unix/iconv/iconv.pro \
279 || die "sed on iconv.pro failed" 294 || die "sed iconv.pro failed"
280 fi 295 fi
281 296
282 # we need some patches for Solaris 297 # we need some patches for Solaris
283 sed -i \
284 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 298 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
285 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 299 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
286 # use GCC over SunStudio 300 # use GCC over SunStudio
287 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 301 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
288 # don't flirt with non-Prefix stuff, we're quite possessive 302 # do not flirt with non-Prefix stuff, we're quite possessive
289 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 303 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
290 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
291 # strip predefined CFLAGS from qmake ( bug #312689 )
292 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
293 305
294 base_src_prepare 306 # apply patches
307 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
308 epatch_user
295} 309}
296 310
297# @FUNCTION: qt4-build_src_configure 311# @FUNCTION: qt4-build_src_configure
298# @DESCRIPTION: 312# @DESCRIPTION:
299# Default configure phase 313# Default configure phase
300qt4-build_src_configure() { 314qt4-build_src_configure() {
301 setqtenv 315 setqtenv
302 myconf="$(standard_configure_options) ${myconf}" 316
317 local conf="
318 -prefix ${QTPREFIXDIR}
319 -bindir ${QTBINDIR}
320 -libdir ${QTLIBDIR}
321 -docdir ${QTDOCDIR}
322 -headerdir ${QTHEADERDIR}
323 -plugindir ${QTPLUGINDIR}
324 -importdir ${QTIMPORTDIR}
325 -datadir ${QTDATADIR}
326 -translationdir ${QTTRANSDIR}
327 -sysconfdir ${QTSYSCONFDIR}
328 -examplesdir ${QTEXAMPLESDIR}
329 -demosdir ${QTDEMOSDIR}
330 -opensource -confirm-license
331 -shared -fast -largefile -stl -verbose
332 -nomake examples -nomake demos"
333
334 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
335 # $(tc-arch). Therefore we convert it to supported values.
336 case "$(tc-arch)" in
337 amd64|x64-*) conf+=" -arch x86_64" ;;
338 ppc-macos) conf+=" -arch ppc" ;;
339 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
340 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
341 x86-macos) conf+=" -arch x86" ;;
342 x86|x86-*) conf+=" -arch i386" ;;
343 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
344 hppa|sh) conf+=" -arch generic" ;;
345 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
346 esac
347
348 conf+=" -platform $(qt_mkspecs_dir)"
349
350 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
351
352 # debug/release
353 if use debug; then
354 conf+=" -debug"
355 else
356 conf+=" -release"
357 fi
358 conf+=" -no-separate-debug-info"
359
360 # exceptions USE flag
361 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
362
363 # disable rpath (bug 380415), except on prefix (bug 417169)
364 use prefix || conf+=" -no-rpath"
365
366 # precompiled headers don't work on hardened, where the flag is masked
367 conf+=" $(qt_use pch)"
368
369 # -reduce-relocations
370 # This flag seems to introduce major breakage to applications,
371 # mostly to be seen as a core dump with the message "QPixmap: Must
372 # construct a QApplication before a QPaintDevice" on Solaris.
373 # -- Daniel Vergien
374 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
303 375
304 # this one is needed for all systems with a separate -liconv, apart from 376 # this one is needed for all systems with a separate -liconv, apart from
305 # Darwin, for which the sources already cater for -liconv 377 # Darwin, for which the sources already cater for -liconv
306 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 378 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
307 myconf+=" -liconv" 379 conf+=" -liconv"
380 fi
308 381
309 if has glib ${IUSE//+} && use glib; then 382 if use_if_iuse glib; then
310 # use -I, -L and -l from configure
311 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 383 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
312 # avoid the -pthread argument 384 # avoid the -pthread argument
313 myconf+=" ${glibflags//-pthread}" 385 conf+=" ${glibflags//-pthread}"
314 unset glibflags 386 unset glibflags
315 fi 387 fi
316 388
317 if use aqua ; then 389 if use aqua; then
318 # On (snow) leopard use the new (frameworked) cocoa code. 390 # On (snow) leopard use the new (frameworked) cocoa code.
319 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 391 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
320 myconf+=" -cocoa -framework" 392 conf+=" -cocoa -framework"
393 # We need the source's headers, not the installed ones.
394 conf+=" -I${S}/include"
395 # Add hint for the framework location.
396 conf+=" -F${QTLIBDIR}"
321 397
322 # We are crazy and build cocoa + qt3support :-) 398 # We are crazy and build cocoa + qt3support :-)
323 if use qt3support; then 399 if use qt3support; then
324 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 400 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
325 -i configure 401 -i configure || die
326 fi 402 fi
327 403 else
328 # We need the source's headers, not the installed ones. 404 conf+=" -no-framework"
329 myconf+=" -I${S}/include"
330
331 # Add hint for the framework location.
332 myconf+=" -F${QTLIBDIR}"
333 fi 405 fi
334 else 406 else
335 # freetype2 include dir is non-standard, thus include it on configure 407 # freetype2 include dir is non-standard, thus pass it to configure
336 # use -I from configure
337 myconf+=" $(pkg-config --cflags freetype2)" 408 conf+=" $(pkg-config --cflags-only-I freetype2)"
338 fi 409 fi
339 410
411 conf+=" ${myconf}"
412 myconf=
413
340 echo ./configure ${myconf} 414 echo ./configure ${conf}
341 ./configure ${myconf} || die "./configure failed" 415 ./configure ${conf} || die "./configure failed"
342 myconf="" 416
417 prepare_directories ${QT4_TARGET_DIRECTORIES}
343} 418}
344 419
345# @FUNCTION: qt4-build_src_compile 420# @FUNCTION: qt4-build_src_compile
421# @DESCRIPTION:
346# @DESCRIPTION: Actual compile phase 422# Actual compile phase
347qt4-build_src_compile() { 423qt4-build_src_compile() {
348 setqtenv 424 setqtenv
349 425
350 build_directories ${QT4_TARGET_DIRECTORIES} 426 build_directories ${QT4_TARGET_DIRECTORIES}
351} 427}
352 428
353# @FUNCTION: qt4-build_src_test 429# @FUNCTION: qt4-build_src_test
354# @DESCRIPTION: 430# @DESCRIPTION:
355# Runs tests only in target directories. 431# Runs tests only in target directories.
356qt4-build_src_test() { 432qt4-build_src_test() {
433 # QtMultimedia does not have any test suite (bug #332299)
434 [[ ${PN} == qt-multimedia ]] && return
435
357 for dir in ${QT4_TARGET_DIRECTORIES}; do 436 for dir in ${QT4_TARGET_DIRECTORIES}; do
358 emake -j1 check -C ${dir} 437 emake -j1 check -C ${dir}
359 done 438 done
360} 439}
361 440
362# @FUNCTION: fix_includes 441# @FUNCTION: fix_includes
363# @DESCRIPTION: 442# @DESCRIPTION:
364# For MacOSX we need to add some symlinks when frameworks are 443# For MacOS X we need to add some symlinks when frameworks are
365# being used, to avoid complications with some more or less stupid packages. 444# being used, to avoid complications with some more or less stupid packages.
366fix_includes() { 445fix_includes() {
367 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 446 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
447 local frw dest f h rdir
368 # Some packages tend to include <Qt/...> 448 # Some packages tend to include <Qt/...>
369 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 449 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
370 450
371 # Fake normal headers when frameworks are installed... eases life later on 451 # Fake normal headers when frameworks are installed... eases life later
372 local dest f 452 # on, make sure we use relative links though, as some ebuilds assume
453 # these dirs exist in src_install to add additional files
454 f=${QTHEADERDIR}
455 h=${QTLIBDIR}
456 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
457 f=${f#*/}
458 h=${h#*/}
459 done
460 rdir=${h}
461 f="../"
462 while [[ ${h} == */* ]] ; do
463 f="${f}../"
464 h=${h#*/}
465 done
466 rdir="${f}${rdir}"
467
373 for frw in "${D}${QTLIBDIR}"/*.framework; do 468 for frw in "${D}${QTLIBDIR}"/*.framework; do
374 [[ -e "${frw}"/Headers ]] || continue 469 [[ -e "${frw}"/Headers ]] || continue
375 f=$(basename ${frw}) 470 f=$(basename ${frw})
376 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 471 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
377 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 472 dosym "${rdir}"/${f}/Headers "${dest}"
378 473
379 # Link normal headers as well. 474 # Link normal headers as well.
380 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 475 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
381 h=$(basename ${hdr}) 476 h=$(basename ${hdr})
382 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 477 dosym "../${rdir}"/${f}/Headers/${h} \
478 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
383 done 479 done
384 done 480 done
385 fi 481 fi
386} 482}
387 483
388# @FUNCTION: qt4-build_src_install 484# @FUNCTION: qt4-build_src_install
389# @DESCRIPTION: 485# @DESCRIPTION:
390# Perform the actual installation including some library fixes. 486# Perform the actual installation including some library fixes.
391qt4-build_src_install() { 487qt4-build_src_install() {
392 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
393 setqtenv 488 setqtenv
489
394 install_directories ${QT4_TARGET_DIRECTORIES} 490 install_directories ${QT4_TARGET_DIRECTORIES}
395 install_qconfigs 491 install_qconfigs
396 fix_library_files 492 fix_library_files
397 fix_includes 493 fix_includes
494
398 # remove .la files since we are building only shared Qt libraries 495 # remove .la files since we are building only shared libraries
399 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 496 prune_libtool_files
400} 497}
401 498
402# @FUNCTION: setqtenv 499# @FUNCTION: setqtenv
500# @INTERNAL
403setqtenv() { 501setqtenv() {
404 # Set up installation directories 502 # Set up installation directories
405 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
406 QTPREFIXDIR=${EPREFIX}/usr 503 QTPREFIXDIR=${EPREFIX}/usr
407 QTBINDIR=${EPREFIX}/usr/bin 504 QTBINDIR=${QTPREFIXDIR}/bin
408 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 505 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
409 QMAKE_LIBDIR_QT=${QTLIBDIR}
410 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 506 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
411 QTDATADIR=${EPREFIX}/usr/share/qt4
412 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 507 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
413 QTHEADERDIR=${EPREFIX}/usr/include/qt4 508 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
414 QTPLUGINDIR=${QTLIBDIR}/plugins 509 QTPLUGINDIR=${QTLIBDIR}/plugins
510 QTIMPORTDIR=${QTLIBDIR}/imports
511 QTDATADIR=${QTPREFIXDIR}/share/qt4
512 QTTRANSDIR=${QTDATADIR}/translations
415 QTSYSCONFDIR=${EPREFIX}/etc/qt4 513 QTSYSCONFDIR=${EPREFIX}/etc/qt4
416 QTTRANSDIR=${QTDATADIR}/translations
417 QTEXAMPLESDIR=${QTDATADIR}/examples 514 QTEXAMPLESDIR=${QTDATADIR}/examples
418 QTDEMOSDIR=${QTDATADIR}/demos 515 QTDEMOSDIR=${QTDATADIR}/demos
419 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 516 QMAKE_LIBDIR_QT=${QTLIBDIR}
517
420 PLATFORM=$(qt_mkspecs_dir) 518 PLATFORM=$(qt_mkspecs_dir)
421
422 unset QMAKESPEC 519 unset QMAKESPEC
423}
424 520
425# @FUNCTION: standard_configure_options 521 export XDG_CONFIG_HOME="${T}"
426# @DESCRIPTION: 522}
427# Sets up some standard configure options, like libdir (if necessary), whether
428# debug info is wanted or not.
429standard_configure_options() {
430 local myconf=
431 523
432 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 524# @FUNCTION: prepare_directories
525# @USAGE: < directories >
526# @INTERNAL
527# @DESCRIPTION:
528# Generates Makefiles for the given list of directories.
529prepare_directories() {
530 # avoid running over the maximum argument number, bug #299810
531 {
532 echo "${S}"/mkspecs/common/*.conf
533 find "${S}" -name '*.pr[io]'
534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
433 538
434 # Disable visibility explicitly if gcc version isn't 4 539 for x in "$@"; do
435 if [[ $(gcc-major-version) -lt 4 ]]; then 540 pushd "${S}"/${x} >/dev/null || die
436 myconf+=" -no-reduce-exports" 541 einfo "Running qmake in: ${x}"
437 fi 542 "${S}"/bin/qmake \
438 543 "LIBS+=-L${QTLIBDIR}" \
439 # precompiled headers doesn't work on hardened, where the flag is masked. 544 "CONFIG+=nostrip" \
440 myconf+=" $(qt_use pch)" 545 || die "qmake failed"
441 546 popd >/dev/null || die
442 if use debug; then 547 done
443 myconf+=" -debug"
444 else
445 myconf+=" -release"
446 fi
447 myconf+=" -no-separate-debug-info"
448
449 use aqua && myconf+=" -no-framework"
450
451 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
452 # $(tc-arch). Therefore we convert it to supported values.
453 case "$(tc-arch)" in
454 amd64|x64-*) myconf+=" -arch x86_64" ;;
455 ppc-macos) myconf+=" -arch ppc" ;;
456 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
457 sparc|sparc-*) myconf+=" -arch sparc" ;;
458 x86-macos) myconf+=" -arch x86" ;;
459 x86|x86-*) myconf+=" -arch i386" ;;
460 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
461 hppa|sh) myconf+=" -arch generic" ;;
462 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
463 esac
464
465 # 4.5: build everything but qt-xmlpatterns w/o exceptions
466 # 4.6: exceptions USE flag
467 local exceptions="-exceptions"
468 case "${PV}" in
469 4.5.*)
470 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
471 ;;
472 *)
473 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
474 ;;
475 esac
476
477 # note about -reduce-relocations:
478 # That flag seems to introduce major breakage to applications,
479 # mostly to be seen as a core dump with the message "QPixmap: Must
480 # construct a QApplication before a QPaintDevice" on Solaris
481 # -- Daniel Vergien
482 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
483
484 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
485 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
486 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
487 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
488 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
489 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
490 ${exceptions}
491 -nomake examples -nomake demos"
492
493 echo "${myconf}"
494} 548}
495 549
496# @FUNCTION: build_directories 550# @FUNCTION: build_directories
497# @USAGE: < directories > 551# @USAGE: < directories >
552# @INTERNAL
498# @DESCRIPTION: 553# @DESCRIPTION:
499# Compiles the code in $QT4_TARGET_DIRECTORIES 554# Compiles the code in the given list of directories.
500build_directories() { 555build_directories() {
501 for x in "$@"; do 556 for x in "$@"; do
502 pushd "${S}"/${x} >/dev/null 557 pushd "${S}"/${x} >/dev/null || die
503 # avoid running over the maximum argument number, bug #299810 558 emake \
504 { 559 AR="$(tc-getAR) cqs" \
505 echo "${S}"/mkspecs/common/*.conf
506 find "${S}" -name '*.pr[io]'
507 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
508 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
509 emake CC="$(tc-getCC)" \ 560 CC="$(tc-getCC)" \
510 CXX="$(tc-getCXX)" \ 561 CXX="$(tc-getCXX)" \
511 LINK="$(tc-getCXX)" || die "emake failed" 562 LINK="$(tc-getCXX)" \
563 RANLIB=":" \
564 STRIP=":" \
565 || die "emake failed"
512 popd >/dev/null 566 popd >/dev/null || die
513 done 567 done
514} 568}
515 569
516# @FUNCTION: install_directories 570# @FUNCTION: install_directories
517# @USAGE: < directories > 571# @USAGE: < directories >
572# @INTERNAL
518# @DESCRIPTION: 573# @DESCRIPTION:
519# run emake install in the given directories, which are separated by spaces 574# Runs emake install in the given directories, which are separated by spaces.
520install_directories() { 575install_directories() {
521 for x in "$@"; do 576 for x in "$@"; do
522 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 577 pushd "${S}"/${x} >/dev/null || die
523 emake INSTALL_ROOT="${D}" install || die "emake install failed" 578 emake INSTALL_ROOT="${D}" install || die "emake install failed"
524 popd >/dev/null || die "Can't popd from ${S}/${x}" 579 popd >/dev/null || die
525 done 580 done
526} 581}
527 582
528# @ECLASS-VARIABLE: QCONFIG_ADD 583# @ECLASS-VARIABLE: QCONFIG_ADD
529# @DESCRIPTION: 584# @DESCRIPTION:
539# @DESCRIPTION: 594# @DESCRIPTION:
540# List variables that should be defined at the top of QtCore/qconfig.h 595# List variables that should be defined at the top of QtCore/qconfig.h
541: ${QCONFIG_DEFINE:=} 596: ${QCONFIG_DEFINE:=}
542 597
543# @FUNCTION: install_qconfigs 598# @FUNCTION: install_qconfigs
599# @INTERNAL
600# @DESCRIPTION:
544# @DESCRIPTION: Install gentoo-specific mkspecs configurations 601# Install gentoo-specific mkspecs configurations.
545install_qconfigs() { 602install_qconfigs() {
546 local x 603 local x
547 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 604 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
548 for x in QCONFIG_ADD QCONFIG_REMOVE; do 605 for x in QCONFIG_ADD QCONFIG_REMOVE; do
549 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 606 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
560 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 617 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
561 fi 618 fi
562} 619}
563 620
564# @FUNCTION: generate_qconfigs 621# @FUNCTION: generate_qconfigs
565# @DESCRIPTION: Generates gentoo-specific configurations 622# @INTERNAL
623# @DESCRIPTION:
624# Generates gentoo-specific qconfig.{h,pri}.
566generate_qconfigs() { 625generate_qconfigs() {
567 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 626 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
568 local x qconfig_add qconfig_remove qconfig_new 627 local x qconfig_add qconfig_remove qconfig_new
569 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 628 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
570 [[ -f ${x} ]] || continue 629 [[ -f ${x} ]] || continue
571 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 630 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
572 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 631 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
584 643
585 # generate list of QT_CONFIG entries from the existing list 644 # generate list of QT_CONFIG entries from the existing list
586 # including qconfig_add and excluding qconfig_remove 645 # including qconfig_add and excluding qconfig_remove
587 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 646 for x in $(sed -n 's/^QT_CONFIG +=//p' \
588 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 647 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
589 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 648 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
590 done 649 done
591 650
592 # replace the existing QT_CONFIG list with qconfig_new 651 # replace the existing QT_CONFIG list with qconfig_new
593 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 652 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
594 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 653 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
618 fi 677 fi
619 fi 678 fi
620} 679}
621 680
622# @FUNCTION: qt4-build_pkg_postrm 681# @FUNCTION: qt4-build_pkg_postrm
682# @DESCRIPTION:
623# @DESCRIPTION: Generate configurations when the package is completely removed 683# Regenerate configuration when the package is completely removed.
624qt4-build_pkg_postrm() { 684qt4-build_pkg_postrm() {
625 generate_qconfigs 685 generate_qconfigs
626} 686}
627 687
628# @FUNCTION: qt4-build_pkg_postinst 688# @FUNCTION: qt4-build_pkg_postinst
689# @DESCRIPTION:
629# @DESCRIPTION: Generate configuration, plus throws a message about possible 690# Regenerate configuration, plus throw a message about possible
630# breakages and proposed solutions. 691# breakages and proposed solutions.
631qt4-build_pkg_postinst() { 692qt4-build_pkg_postinst() {
632 generate_qconfigs 693 generate_qconfigs
633} 694}
634 695
635# @FUNCTION: skip_qmake_build_patch 696# @FUNCTION: skip_qmake_build
697# @INTERNAL
636# @DESCRIPTION: 698# @DESCRIPTION:
637# Don't need to build qmake, as it's already installed from qt-core 699# Patches configure to skip qmake compilation, as it's already installed by qt-core.
638skip_qmake_build_patch() { 700skip_qmake_build() {
639 # Don't need to build qmake, as it's already installed from qt-core
640 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 701 sed -i -e "s:if true:if false:g" "${S}"/configure || die
641} 702}
642 703
643# @FUNCTION: skip_project_generation_patch 704# @FUNCTION: skip_project_generation
705# @INTERNAL
644# @DESCRIPTION: 706# @DESCRIPTION:
645# Exit the script early by throwing in an exit before all of the .pro files are scanned 707# Exit the script early by throwing in an exit before all of the .pro files are scanned.
646skip_project_generation_patch() { 708skip_project_generation() {
647 # Exit the script early by throwing in an exit before all of the .pro files are scanned
648 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 709 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
649 -i "${S}"/configure || die "Sed failed"
650} 710}
651 711
652# @FUNCTION: symlink_binaries_to_buildtree 712# @FUNCTION: symlink_binaries_to_buildtree
713# @INTERNAL
653# @DESCRIPTION: 714# @DESCRIPTION:
654# Symlink generated binaries to buildtree so they can be used during compilation 715# Symlinks generated binaries to buildtree, so they can be used during compilation time.
655# time
656symlink_binaries_to_buildtree() { 716symlink_binaries_to_buildtree() {
657 for bin in qmake moc uic rcc; do 717 for bin in qmake moc uic rcc; do
658 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 718 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
659 done 719 done
660} 720}
661 721
662# @FUNCTION: fix_library_files 722# @FUNCTION: fix_library_files
723# @INTERNAL
663# @DESCRIPTION: 724# @DESCRIPTION:
664# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 725# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
665# moves the *.pc-files into the pkgconfig directory 726# moves the *.pc files into the pkgconfig directory.
666fix_library_files() { 727fix_library_files() {
728 local libfile
667 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 729 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
668 if [[ -e ${libfile} ]]; then 730 if [[ -e ${libfile} ]]; then
669 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 731 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
670 fi 732 fi
671 done 733 done
672 734
673 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 735 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
674 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 736 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
675 if [[ -e ${libfile} ]]; then 737 if [[ -e ${libfile} ]]; then
676 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 738 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
677 739
678 # Move .pc files into the pkgconfig directory 740 # Move .pc files into the pkgconfig directory
679 dodir ${QTPCDIR#${EPREFIX}} 741 dodir ${QTPCDIR#${EPREFIX}}
680 mv ${libfile} "${D}"/${QTPCDIR}/ \ 742 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
681 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
682 fi 743 fi
683 done 744 done
684 745
685 # Don't install an empty directory 746 # Don't install an empty directory
686 rmdir "${D}"/${QTLIBDIR}/pkgconfig 747 rmdir "${D}"/${QTLIBDIR}/pkgconfig
687} 748}
688 749
689# @FUNCTION: qt_use 750# @FUNCTION: qt_use
690# @USAGE: < flag > [ feature ] [ enableval ] 751# @USAGE: < flag > [ feature ] [ enableval ]
691# @DESCRIPTION: 752# @DESCRIPTION:
692# This will echo "${enableval}-${feature}" if <flag> is enabled, or 753# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
693# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 754# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
694# will be used for that. If [enableval] is not specified, it omits the 755# will be used for that. If [enableval] is not specified, it omits the
695# assignment-part 756# "-${enableval}" part.
696qt_use() { 757qt_use() {
697 local flag=$1 758 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
698 local feature=$1
699 local enableval=
700
701 [[ -n $2 ]] && feature=$2
702 [[ -n $3 ]] && enableval=-$3
703
704 if use ${flag}; then
705 echo "${enableval}-${feature}"
706 else
707 echo "-no-${feature}"
708 fi
709} 759}
710 760
711# @FUNCTION: qt_mkspecs_dir 761# @FUNCTION: qt_mkspecs_dir
712# @RETURN: the specs-directory w/o path 762# @RETURN: the specs-directory w/o path
713# @DESCRIPTION: 763# @DESCRIPTION:
714# Allows us to define which mkspecs dir we want to use. 764# Allows us to define which mkspecs dir we want to use.
715qt_mkspecs_dir() { 765qt_mkspecs_dir() {
716 # Allows us to define which mkspecs dir we want to use.
717 local spec 766 local spec=
718 767
719 case ${CHOST} in 768 case "${CHOST}" in
720 *-freebsd*|*-dragonfly*) 769 *-freebsd*|*-dragonfly*)
721 spec=freebsd ;; 770 spec=freebsd ;;
722 *-openbsd*) 771 *-openbsd*)
723 spec=openbsd ;; 772 spec=openbsd ;;
724 *-netbsd*) 773 *-netbsd*)
735 *-solaris*) 784 *-solaris*)
736 spec=solaris ;; 785 spec=solaris ;;
737 *-linux-*|*-linux) 786 *-linux-*|*-linux)
738 spec=linux ;; 787 spec=linux ;;
739 *) 788 *)
740 die "Unknown CHOST, no platform choosen." 789 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
741 esac 790 esac
742 791
743 CXX=$(tc-getCXX) 792 case "$(tc-getCXX)" in
744 if [[ ${CXX} == *g++* ]]; then 793 *g++*)
745 spec+=-g++ 794 spec+=-g++ ;;
746 elif [[ ${CXX} == *icpc* ]]; then 795 *icpc*)
747 spec+=-icc 796 spec+=-icc ;;
748 else 797 *)
749 die "Unknown compiler ${CXX}." 798 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
750 fi 799 esac
751 if [[ -n ${LIBDIR/lib} ]]; then
752 spec+=-${LIBDIR/lib}
753 fi
754 800
755 # Add -64 for 64bit profiles 801 # Add -64 for 64bit profiles
756 if use x64-freebsd || 802 if use x64-freebsd ||
757 use amd64-linux || 803 use amd64-linux ||
758 use x64-macos || 804 use x64-macos ||
763 fi 809 fi
764 810
765 echo "${spec}" 811 echo "${spec}"
766} 812}
767 813
768# @FUNCTION: qt_assistant_cleanup
769# @RETURN: nothing
770# @DESCRIPTION:
771# Tries to clean up tools.pro for qt-assistant ebuilds
772# Meant to be called in src_prepare
773qt_assistant_cleanup() {
774 # different versions (and branches...) may need different handling,
775 # add a case if you need special handling
776 case "${MY_PV_EXTRA}" in
777 *kde-qt*)
778 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
779 -e "/mac/,/^embedded.*makeqpf$/d" \
780 -i tools/tools.pro || die "patching tools.pro failed"
781 ;;
782 *)
783 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
784 -e "/mac/,/^embedded.*makeqpf$/d" \
785 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
786 -i tools/tools.pro || die "patching tools.pro failed"
787 ;;
788 esac
789}
790
791# @FUNCTION: qt_nolibx11 814# @FUNCTION: qt_nolibx11
792# @RETURN: nothing 815# @INTERNAL
793# @DESCRIPTION: 816# @DESCRIPTION:
794# Ignore X11 tests for packages that don't need X libraries installed 817# Ignore X11 tests for packages that don't need X libraries installed.
795qt_nolibx11() { 818qt_nolibx11() {
796 einfo "removing X11 check to allow X-less compilation"
797 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 819 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
798 die "x11 check sed failed" 820 die "x11 check sed failed"
799} 821}
800 822
801EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 823EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.82  
changed lines
  Added in v.1.143

  ViewVC Help
Powered by ViewVC 1.1.20